/*
 * ============================================================================
 * (C) Copyright IBM Corporation 2006, 2007, 2008.  All Rights Reserved.
 * 
 * You may only copy, modify, and distribute these samples internally.
 * These samples have not been tested under all conditions and are provided
 * to you by IBM without obligation of support of any kind.
 *
 * IBM PROVIDES THESE SAMPLES "AS IS" SUBJECT TO ANY STATUTORY WARRANTIES THAT
 * CANNOT BE EXCLUDED. IBM MAKES NO WARRANTIES OR CONDITIONS, EITHER EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OR
 * CONDITIONS OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND
 * NON-INFRINGEMENT REGARDING THESE SAMPLES OR TECHNICAL SUPPORT, IF ANY.
 * ============================================================================
 */
 import zero.core.groovysupport.ZeroObject
 import zero.atom.Atom
 import zero.json.Json
 import zero.util.UTF8FileWriter
 
 class FileJsonList implements ZeroObject {
    

 
public static def process(def resourceName, def cmd, def id, def data) {
	
	if (cmd=="list") {
		return readData(resourceName)
		
	} else if (cmd=="retrieve") {
		def entryList = getEntryList(readData(resourceName))
		int index = getIndex(id, entryList)
		return (index > -1) ? entryList.get(index) : null
				
	} else if (cmd=="delete") {
		def dataSet = readData(resourceName)
		def entryList = getEntryList(dataSet)
		int index = getIndex(id, entryList)
		if (index > -1) {
			entryList.set(index, [:])
			writeData(resourceName, dataSet)
			return true
		} else {
			return false
		}
		
	} else if (cmd=="update") {
		def dataSet = readData(resourceName)
		def entryList = getEntryList(dataSet)
		int index = getIndex(id, entryList)
		if (index > -1) {
			entryList.set(index, data)
			writeData(resourceName, dataSet)
			return true
		} else {
			return false
		}
		
	} else if (cmd=="create") {
		def dataSet = readData(resourceName)
		def entryList = getEntryList(dataSet)
		data.id = (entryList.size()+1).toString()
		entryList.add(data)
		writeData(resourceName, dataSet)
		return data
	} 
}
public static def getEntryList(def dataSet) {
	def list = []
	dataSet.each{ k, v ->
		if (k == "entries") { list = v }
	}
	return list;
}
public static int getIndex(def id, def list) {
	int index = -1
	int i = -1
	list.each { 
			i++
			it.each { k, v -> if ((k == "id") && (v == id)) index = i } 
	}
	return index
}

public static def readData(resourceName) {
	File dataFile = zero.core.utils.VDirectory.getVFile("/data/${resourceName}Data.json")
	def  dataSet = Json.decode( new FileInputStream(dataFile), true );
	return dataSet
}

public static void writeData(resourceName, dataSet) {
	String output = Json.encode(dataSet, true);
	File dataFile = zero.core.utils.VDirectory.getVFile("/data/${resourceName}Data.json");
	def fw = new UTF8FileWriter(dataFile) 
	fw.write(output)
	fw.flush()
	fw.close()
} 
}
