/*
 * ============================================================================
 * (C) Copyright IBM Corporation 2006, 2007, 2008.  All Rights Reserved.
 * 
 * You may only copy, modify, and distribute these samples internally.
 * These samples have not been tested under all conditions and are provided
 * to you by IBM without obligation of support of any kind.
 *
 * IBM PROVIDES THESE SAMPLES "AS IS" SUBJECT TO ANY STATUTORY WARRANTIES THAT
 * CANNOT BE EXCLUDED. IBM MAKES NO WARRANTIES OR CONDITIONS, EITHER EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OR
 * CONDITIONS OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND
 * NON-INFRINGEMENT REGARDING THESE SAMPLES OR TECHNICAL SUPPORT, IF ANY.
 * ============================================================================
 */
 import zero.core.groovysupport.ZeroObject
 import zero.atom.Atom
 import zero.json.Json
 import zero.util.UTF8FileWriter
 
 class FileJsonMap implements ZeroObject {
    

public static def process(def resourceName, def cmd, def id, def data) {
	
	if (cmd=="list") {
		def dataMap = readData(resourceName)
		def list = []
		dataMap.each { k, v -> 
			def map = [:]
			map.id = k
			map.content = v
			list.add(map)
		}
		return list;
		
	} else if (cmd=="retrieve") {
		def map =  readData(resourceName)
		return map.get(id)
				
	} else if (cmd=="delete") {
		def map = readData(resourceName)
		if (map.contains(id)) {
			map.remove(id)
			writeData(resourceName, map)
			return true
		} else {
			return false
		}
		
	} else if (cmd=="update") {
		def map = readData(resourceName)
		if (map.contains(id)) {
			map.put(id, data)
			writeData(resourceName, map)
			return true
		} else {
			return false
		}
		
	} else if (cmd=="create") {
		def map = readData(resourceName)
		map.put(id, data)
	    writeData(resourceName, map)
		return data
	} 
}
public static def getEntryList(def dataSet) {
	def list = []
	dataSet.each{ k, v ->
		if (k == "entries") { list = v }
	}
	return list;
}
public static int getIndex(def id, def list) {
	int index = -1
	int i = -1
	list.each { 
			i++
			it.each { k, v -> if ((k == "id") && (v == id)) index = i } 
	}
	return index
}

public static def readData(resourceName) {
	File dataFile = zero.core.utils.VDirectory.getVFile("/data/${resourceName}Data.json")
	def  dataSet = Json.decode( new FileInputStream(dataFile), true );
	return dataSet
}

public static void writeData(resourceName, dataSet) {
	String output = Json.encode(dataSet, true);
	File dataFile = zero.core.utils.VDirectory.getVFile("/data/${resourceName}Data.json");
	def fw = new UTF8FileWriter(dataFile) 
	fw.write(output)
	fw.flush()
	fw.close()
} 
}
