/*
 * ============================================================================
 * (C) Copyright IBM Corporation 2006, 2007, 2008.  All Rights Reserved.
 * 
 * You may only copy, modify, and distribute these samples internally.
 * These samples have not been tested under all conditions and are provided
 * to you by IBM without obligation of support of any kind.
 *
 * IBM PROVIDES THESE SAMPLES "AS IS" SUBJECT TO ANY STATUTORY WARRANTIES THAT
 * CANNOT BE EXCLUDED. IBM MAKES NO WARRANTIES OR CONDITIONS, EITHER EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OR
 * CONDITIONS OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND
 * NON-INFRINGEMENT REGARDING THESE SAMPLES OR TECHNICAL SUPPORT, IF ANY.
 * ============================================================================
 */
 import zero.core.groovysupport.ZeroObject
 import zero.atom.Atom
 
 class SimpleProtocol implements ZeroObject {
    
	public static void onList(String dataHandlerName) {  

		def resourceName = zget("/event/collectionInfo#0/collection") 
		
		def result = process(dataHandlerName, resourceName, "list", null, null)
		
	    zput("/request/status", HttpURLConnection.HTTP_OK)
	    zput("/request/view", 'atom')
	    zput("/request/atom/output", result)
	    zput("/request/atom/resourceName", resourceName)
	    render() 
        
	}
 

	public static void onCreate(String dataHandlerName) {  
	
		def resourceName = zget("/event/collectionInfo#0/collection") 
	    def input = zget("/request/input") 
	
		def data = Atom.decode(input, "entry", resourceName)
		
		def result  = process(dataHandlerName, resourceName, "create", null, data)
		
		if (result) {
			zput("/request/status", HttpURLConnection.HTTP_NO_CONTENT)
		    zput("/request/view", 'atom')
		    zput("/request/atom/docType", 'entry')
		    zput("/request/atom/output", result)
		    zput("/request/atom/resourceName", resourceName)
		    render() 
		} else {
			zput("/request/status", HttpURLConnection.HTTP_BAD_REQUEST)
		}

    }
 

	public static void onRetrieve(String dataHandlerName) { 
	
		def resourceName = zget("/event/collectionInfo#0/collection") 
		def id = zget("/event/collectionInfo#0/memberId")
		
		def result = process(dataHandlerName, resourceName, "retrieve", id, null);
	
	    if (result) {
			zput("/request/status", HttpURLConnection.HTTP_OK)
		    zput("/request/view", 'atom')
		    zput("/request/atom/docType", 'entry')
		    zput("/request/atom/output", result)
		    zput("/request/atom/resourceName", resourceName)
		    render() 
	    } else {
			zput("/request/statsu", HttpURLConnection.HTTP_NOT_FOUND)
	    }
	}

 

	public static void onUpdate(String dataHandlerName) { 
	
		def resourceName = zget("/event/collectionInfo#0/collection") 
		def id = zget("/event/collectionInfo#0/memberId")
		def input = zget("/request/input") 
		def data = Atom.decode(input, "entry", resourceName )
		def result  = process(dataHandlerName, resourceName, "update", id, data)
	
		if (result) {
			zput("/request/status", HttpURLConnection.HTTP_NO_CONTENT)
		} else {
			zput("/request/status", HttpURLConnection.HTTP_BAD_REQUEST)
		}
	
	}


	public static void onDelete(String dataHandlerName) { 
	
		def resourceName = zget("/event/collectionInfo#0/collection") 
		def id = zget("/event/collectionInfo#0/memberId")
		
		def result  = process(dataHandlerName, resourceName, "delete", id, null)
		
		if (result) {
			zput("/request/status", HttpURLConnection.HTTP_NO_CONTENT)
		} else {
			zput("/request/status", HttpURLConnection.HTTP_BAD_REQUEST)
		}
	
	}
 
	public static def process(def dataHandlerName, def resourceName, def cmd, def id, def data) {
		
		if ( "FileJsonList".equals(dataHandlerName) ) {
			return FileJsonList.process(resourceName, cmd, id, data)
		} else if ( "FileJsonMap".equals(dataHandlerName) ) {
			return FileJsonMap.process(resourceName, cmd, id, data)
		} else if ( "ZRMData".equals(dataHandlerName) ) {
			//return ZRMData.process(resourceName, cmd, id, data)
		} else {
			 System.out.println ("bad dataHandlerName")
		}
	}
 
}
