/*
 * ============================================================================
 * (C) Copyright IBM Corporation 2006, 2007, 2008.  All Rights Reserved.
 * 
 * You may only copy, modify, and distribute these samples internally.
 * These samples have not been tested under all conditions and are provided
 * to you by IBM without obligation of support of any kind.
 *
 * IBM PROVIDES THESE SAMPLES "AS IS" SUBJECT TO ANY STATUTORY WARRANTIES THAT
 * CANNOT BE EXCLUDED. IBM MAKES NO WARRANTIES OR CONDITIONS, EITHER EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OR
 * CONDITIONS OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND
 * NON-INFRINGEMENT REGARDING THESE SAMPLES OR TECHNICAL SUPPORT, IF ANY.
 * ============================================================================
 */

import zero.atom.Atom
 
def onGET() {
	
	// configure feed elements
	def feed = [:]
	feed.title = "Authors of the Popular Classics"
    
    // configure entry elements
    def link = [:]
    link.rel = "http://localhost:8080/resources/biographies"
    def entry = [:]
	entry.link = [link]
    zput("/request/atom/entry", entry)

    // create new data set
	def list = []
	def classics = Atom.decode ("http://localhost:8080/resources/classics", "feed", "classics")

	classics.entries.each { classic ->
 		if ( classic.published  && classic.copies_in_print.toInteger() > 4000 ) {
 			def item = [:]
 			def author = classic.authors[0]
 			item.title = author
            def authorKey = author.replace(" ", "_")
 			def authorData = Atom.decode("http://localhost:8080/resources/authors/${authorKey}", "entry", "authors")
 			def newLink = [:]
 			newLink.href = authorData.content.value
 			item.links =  classic.links + [newLink]
 			list.add(item)
 		}
	}
	feed.entries = list

	// render
    request.view='atom'
    request.atom.output =  feed
    render() 
        
}
